<!DOCTYPE html>
<html>
    <head>
        <title>RunKit: Endpoint Documentation</title>


        <script src="https://static.runkitcdn.com/assets/vendor/jquery/jquery.min.js"></script>
        <script src="https://static.runkitcdn.com/assets/vendor/bootstrap/bootstrap.min.js?v=4.1.3"></script>

        <meta name="keywords" content="RunKit REPL tonic endpoint playground javascript node npm module prototype prototyping API server" />
        <meta name="author" content="runkit.com" />
        <meta name="description" content="RunKit notebooks are interactive javascript playgrounds connected to a complete node environment right in your browser. Every npm module pre-installed.">
        <meta name="viewport" content="width=device-width, initial-scale=0.5">
        <link type="application/opensearchdescription+xml" rel="search" title="RunKit" href="https://static.runkitcdn.com/search.xml"/>

        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Fira+Sans:400,700|Ubuntu+Mono:400|Roboto:300,400,700" type="text/css">
        <link rel="stylesheet" href="https://static.runkitcdn.com/assets/vendor/font-awesome/css/font-awesome.min.css" />
        <link rel="stylesheet" href="https://static.runkitcdn.com/assets/vendor/codemirror/lib/codemirror.css"/>
        <link rel="stylesheet" href="https://themes.runkitcdn.com/runkit-light.css?v=ad22fa945599b4c004af2389b5ab52ae1ec0ac7c" />
        <link rel="stylesheet" href="https://static.runkitcdn.com/assets/vendor/bootstrap/bootstrap.min.css?v=4.1.3"/>
        <link rel="stylesheet" href="https://static.runkitcdn.com/assets/styles/base.css?v=ad22fa945599b4c004af2389b5ab52ae1ec0ac7c"/>
        <link rel="stylesheet" href="https://static.runkitcdn.com/assets/styles/static.css?v=ad22fa945599b4c004af2389b5ab52ae1ec0ac7c"/>
        <link rel="stylesheet" href="https://static.runkitcdn.com/assets/vendor/photon/icons.min.css">
    </head>

    <body class="static-page">

        <header>
            <nav class="primary-nav navbar navbar-expand-sm navbar-light">
              <div class="container justify-content-between">
                <ul class="navbar-nav mr-auto">
                  <li class="nav-item">
                    <a class="logo navbar-brand" href="/home">RunKit</a>
                  </li>
                </ul>

                <ul class="navbar-nav secondary-links text-right navbar-right">
                  <div class="collapse navbar-collapse" id="myNavbar">
                    <ul class="navbar-nav">
                      <li class="nav-item"><a class="nav-link" href="https://discuss.runkit.com">Forum</a></li>
                      <li class="nav-item"><a class="nav-link" href="http://blog.runkit.com/">Blog</a></li>
                      <li class="nav-item"><a class="nav-link" href="/docs">Documentation</a></li>
                      <li class="nav-item"><a class="nav-link" href="/explore">Explore</a></li>
                    </ul>
                  </div>

                  <div class="navbar-user-menu-container">
            
                    <li class="nav-item dropdown hidden-md-down">
                      <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <img style="border-radius: 50%; height:25px;" src = "https://secure.gravatar.com/avatar/ad1617daf09acb951bf2544505fd1385?s=32&amp;d=identicon" />
                      </a>
                      <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdownMenuLink">
                        <a class="dropdown-item disabled" href="#">Signed in as <b>archangel-ambriel</b></a>

                        <a class="dropdown-item" href="/archangel-ambriel">My Notebooks</a>
                        <a class="dropdown-item" href="/new">New Notebook</a>

                        <div class="dropdown-divider"></div>
                        <a class="dropdown-item" href="/logout">Log out</a>
                      </div>
                    </li>
                    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#myNavbar">
                      <span class="navbar-toggler-icon"></span>
                    </button>
                  </div>
                </ul>
              </div>
            </nav>
        </header>

        <div id="main-content">
        <div class="page-wrapper">
<style>

pre {
    border: 0;
    background-color: #f9f9f9;
}

</style>

<h1>
    <span style="font-weight: bold;">RunKit Endpoint</span>
    <span style="display: block; font-size: 22px; margin-top: 16px;">Build APIs without any servers</span>
</h1>

<p style="font-size: 12px;">
    Note: This is a beta release! We may make changes as Endpoint develops.
</p>

<hr />

<p>
    <strong>Endpoint</strong> is a fast and simple way to write code with Node.js that can respond to HTTP requests from anywhere. There's no need to manage servers or deployments, instead just write code in RunKit. Getting started is as easy as implementing one function. Here's a simple example:
</p>

<script src="https://embed.runkit.com"></script>
<div id="embed1">
exports.endpoint = function(request, response) {
    response.end("Hello world!");
}
</div>
<script>
    var el = document.getElementById("embed1");
    var source = RunKit.sourceFromElement(el);
    el.innerHTML = "";
    RunKit.createNotebook({
        source: source,
        element: el,
        mode: 'endpoint',
        onURLChanged: function(notebook) {
            var link = document.getElementById("endpointLink");
            var text = document.getElementById("endpointText");
            link.href = notebook.endpointURL + "/branches/master";
            text.innerHTML = "curl " + notebook.endpointURL;
        }
    })
</script>

<p>
    The code above is now a real <a id="endpointLink" href="#" target="_blank">running endpoint</a>.  Changes will be reflected in real time. And just like with any notebook, you can (and should!) publish permanent versions as you develop your APIs. Go ahead, try curling it:

    <kbd id="endpointText" class="prompt" style="display: block; margin-top: 12px; font-size: 110%; padding: 0.5em;">
    </kbd>
</p>

<hr class="wide-margin" />

<h3>The Details</h3>

<p>
    Any RunKit document that exports a function called <code>endpoint</code> can serve requests. The function should have the same signature as the callback passed to <code>server.listen</code> in node directly. The only change here is removing the explicit server creation and port binding.
</p>

<pre style="margin: 20px 40px;" id="colorize"><code>exports.endpoint = function(request, response) {
    // your code goes here
}</code></pre>

<ul style="margin: 20px 40px;">
    <li>
        <strong>request</strong>
        <div>
            An instance of node's <a href="https://nodejs.org/docs/v0.10.40/api/http.html#http_http_incomingmessage">http.IncomingMessage</a>, with full access to its properties and methods.
        </div>
    </li>
    <li style="margin-top: 12px">
        <strong>response</strong>
        <div>
            An instance of node's <a href="https://nodejs.org/docs/v0.10.40/api/http.html#http_class_http_serverresponse">http.ServerResponse</a>, also with full access to its properties and methods.
        </div>
    </li>
</ul>

<h4>URLs</h4>

<p>Every RunKit Notebook has a main url like:</p>
<pre style="margin: 0 40px;"><a href="https://runkit.com/runkit/endpoint-demo-1">https://<strong>runkit.com</strong>/runkit/endpoint-demo-1</a></pre>

<p>as well as specific revision URLs like:</p>
<pre style="margin: 0 40px;"><a href="https://runkit.com/runkit/endpoint-demo-1/branches/master">https://runkit.com/runkit/endpoint-demo-1/branches/master</a>
<a href="https://runkit.com/runkit/endpoint-demo-1/1.0.0">https://runkit.com/runkit/endpoint-demo-1/1.0.0</a></pre>

<p>Notebooks access through endpoint are hosted on <code>runkit.io</code> and each user has their own subdomain. Unlike the main notebook page, which has a shorthand for accessing the latest revision, you'll just need to specifically reference <code>/branches/master</code>. Being explicit has an advantage; it means that not only will your notebook respond to urls like:
</p>

<pre style="margin: 0 40px;"><a href="https://runkit.runkit.io/endpoint-demo-1/branches/master">https://runkit.<strong>runkit.io</strong>/endpoint-demo-1/branches/master</a></pre>

<p>It also responds to any sub-paths like these:</p>

<pre style="margin: 0 40px;"><a href="https://runkit.runkit.io/endpoint-demo-1/branches/master/hello/world">https://runkit.runkit.io/endpoint-demo-1/branches/master/hello/world</a>
<a href="https://runkit.runkit.io/endpoint-demo-1/branches/master/use/the/force">https://runkit.runkit.io/endpoint-demo-1/branches/master/use/the/force</a></pre>

<p>You can use the environment variable <code>process.env.RUNKIT_MOUNT_PATH</code> to programatically check the base path of your endpoint, and <code>process.env.RUNKIT_ENDPOINT_URL</code> to get the base URL of your endpoint.</p>

<hr class="wide-margin" />

<h3 style="margin-bottom: 24px">Examples</h3>

<h4>Simple JSON API</h4>

<p>Want to build a simple API that sends/receives JSON messages, without dealing with HTTP at all? We built a simple helper for this that sets it up for you. You can see how the helper is <a href="/runkit/json-endpoint">implemented</a>, or check out this <a href="/runkit/json-endpoint-example-1">usage example</a>. You can also return a promise directly, or use a <a href="/runkit/json-endpoint-example-2">done callback</a>.</p>

<div id="ex2">
var endpoint = require("@runkit/runkit/json-endpoint/1.0.0");
endpoint(exports, async function(incomingData)
{
    var result = await doSomething(incomingData.body)
    return result
})
</div>

<h4>Using Endpoint with Express</h4>

<p>We've built a simple wrapper to set up a fully compatible Express app with <strong>Endpoint</strong>. Just require our wrapper instead of express, and pass in the exports object to your app constructor. You can see how the helper is <a href="/runkit/express-endpoint">implemented</a>, or check out this <a href="/runkit/express-endpoint-demo">usage example</a>.</p>

<div id="ex3">
var express = require("@runkit/runkit/express-endpoint/1.0.0");
var app = express(exports);

app.get("/:name", (req, res) => res.send(`hey ${req.params.name}`))
</div>

<script>
    ["ex2", "ex3"].forEach(function(id) {
        var el = document.getElementById(id);
        var source = RunKit.sourceFromElement(el);
        el.innerHTML = "";
        RunKit.createNotebook({ element: el, source: source, readOnly: true })
    })
    var el = document.getElementById("ex2")
</script>

<hr class="wide-margin" />

<h4>Restrictions</h4>

<p>
    Endpoint is only available over <code>https</code>.
</p>

<p>
    Although RunKit lets you use a top level <code>await</code> at any time, you can't use a top level await before exporting your endpoint function.
</p>

<p>
    Requests must terminate within 60 seconds. Endpoints are rate limited, and during the beta period they are restricted to non-commercial use. If you need to raise rate limits, or would like to use Endpoint commercially, just <a href="mailto:support@runkit.com">get in touch</a>.
</p>

<script src="https://static.runkitcdn.com/assets/vendor/codemirror/lib/codemirror.js"></script>
<script src="https://static.runkitcdn.com/assets/vendor/codemirror/mode/jsx/jsx.js"></script>
<script src="https://static.runkitcdn.com/assets/vendor/codemirror/addon/runmode/runmode.js"></script>
<script src="https://static.runkitcdn.com/assets/vendor/codemirror/addon/runmode/colorize.js"></script>

<script>
    CodeMirror.colorize([document.getElementById("colorize")], "jsx");
</script>
</div>

        </div>

        <footer>
            <div>
                <a href="https://twitter.com/runkitdev"><img src="https://static.runkitcdn.com/assets/images/integrations/twitter.svg" title="twitter" height="16" /></a>
            </div>
            <div id="copy">
                &copy; 2020 runkit &bull;
                <a href="/s/privacy">privacy</a> &middot;
                <a href="/s/terms">terms</a> &middot;
                <a href="/about">about</a> &middot;
                <a href="/jobs">jobs</a> &middot;
                <a href="http://blog.runkit.com">blog</a> &middot;
                <a href="https://discuss.runkit.com">forum</a>
            </div>
        </footer>

        <script>
          (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
          (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
          m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
          })(window,document,'script','//www.google-analytics.com/analytics.js','ga');

          ga('create', 'UA-65519033-1', 'auto');
          ga('send', 'pageview');
        </script>

    </body>
</html>
